<?php
if ( function_exists('register_sidebar') )
    register_sidebar(array(
        'before_widget' => '<li id="%1$s" class="widget %2$s">',
        'after_widget' => '</li>',
        'before_title' => '<h2 class="widgettitle">',
        'after_title' => '</h2>',
    ));
    
function get_var_preffix(){
	return "teqvar";
}

function delete_theme_options(){
	$shortname = get_var_preffix();
	delete_option($shortname."_is_links");
	delete_option($shortname."_is_archive");
	delete_option($shortname."_is_calendar");
}

function get_theme_option($option, $default = "No"){
	#delete_theme_options();
	$optionValue = get_option($option);
	if(!$optionValue){
		return $default;
	}else{
		return $optionValue;	
	}
}

function get_my_theme_options(){
	$shortname = get_var_preffix();
	$options = array (
		array(	"name" => "Links",
				"id" => $shortname."_is_links",
				"type" => "select",
				"std" => "Yes",
				"options" => array("Yes", "No")),
		array(	"name" => "Archive",
				"id" => $shortname."_is_archive",
				"type" => "select",
				"std" => "Yes",
				"options" => array("Yes", "No")),
		array(	"name" => "Calendar",
				"id" => $shortname."_is_calendar",
				"type" => "select",
				"std" => "Yes",
				"options" => array("Yes", "No"))
	);
	return $options;
}


function mytheme_add_admin() {

	$themename = "Black Che Grafitti";
	$shortname = get_var_preffix();
	$options = get_my_theme_options();
	#echo "<pre>";
	#print_r($_REQUEST);
	if ( $_GET['page'] == basename(__FILE__) ) {
		if ( 'save' == $_REQUEST['action'] ) {
				foreach ($options as $value) {
					update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }

				foreach ($options as $value) {
					if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }

				header("Location: themes.php?page=functions.php&saved=true");
				die;

		} else if( 'reset' == $_REQUEST['action'] ) {
			foreach ($options as $value) {
				delete_option( $value['id'] ); }

			header("Location: themes.php?page=functions.php&reset=true");
			die;

		}
	}
    add_theme_page("Green Grass Options Page", "Theme Options", 'edit_themes', basename(__FILE__), 'mytheme_admin');
}

function mytheme_admin() {
	$shortname = get_var_preffix();
	$themename = "Green Grass";

	if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings saved.</strong></p></div>';
	if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings reset.</strong></p></div>';
	
?>
<div class="wrap">
<h2>"Black Che Grafitti" Options</h2>

<form method="post">

<table class="optiontable">
	<tr valign="top"> 
		<th scope="row">Archive visible:</th>
		<td>
			<select name="<?php echo $shortname; ?>_is_archive" id="<?php echo $shortname; ?>_is_archive">
				<option>Yes</option>
				<option <?php if(get_theme_option($shortname.'_is_archive','Yes')=='No' ){ echo 'selected="selected"'; }?>>No</option>
			</select>
		</td>
	</tr>
	<tr valign="top"> 
		<th scope="row">Calendar visible:</th>
		<td>
			<select name="<?php echo $shortname; ?>_is_calendar" id="<?php echo $shortname; ?>_is_calendar">
				<option>Yes</option>
				<option <?php if(get_theme_option($shortname.'_is_calendar','Yes')=='No' ){  echo 'selected="selected"'; }?>>No</option>
			</select>
		</td>
	</tr>
	<tr valign="top"> 
		<th scope="row">Links visible:</th>
		<td>
			<select name="<?php echo $shortname; ?>_is_links" id="<?php echo $shortname; ?>_is_links">
				<option>Yes</option>
				<option <?php if(get_theme_option($shortname.'_is_links','Yes')=='No' ){ echo 'selected="selected"'; }?>>No</option>
			</select>
		</td>
	</tr>
</table>

<p class="submit">
<input name="save" type="submit" value="Save changes" />	
<input type="hidden" name="action" value="save" />
</p>
</form>
<form method="post">
<p class="submit">
<input name="reset" type="submit" value="Reset" />
<input type="hidden" name="action" value="reset" />
</p>
</form>

<?php
}

add_action('admin_menu', 'mytheme_add_admin'); 

/*class Walker_Page_More extends Walker_Page {
	function walk_more( $elements, $max_depth) {
		
		$args = array_slice(func_get_args(), 2);
		$output = '';

		if ($max_depth < -1) //invalid parameter
			return $output;

		if (empty($elements)) //nothing to walk
			return $output;

		$id_field = $this->db_fields['id'];
		$parent_field = $this->db_fields['parent'];

		// flat display
		if ( -1 == $max_depth ) {
			$empty_array = array();
			if (count($elements)<6)
			{
				foreach ( $elements as $e )
					$this->display_element( $e, $empty_array, 1, 0, $args, $output );
			}
			else
			{
				$i=0;
				foreach ( $elements as $e ){
					$i++;
					if ($i==5)
						$output.='<a title="More" href="#"><ul>';
					$this->display_element( $e, $empty_array, 1, 0, $args, $output );
				}
				if ($i>=5)
					$output.='</ul>';
			}
			return $output;
		}

		/*
		 * need to display in hierarchical order
		 * seperate elements into two buckets: top level and children elements
		 * children_elements is two dimensional array, eg.
		 * children_elements[10][] contains all sub-elements whose parent is 10.
		 */
		/*$top_level_elements = array();
		$children_elements  = array();
		foreach ( $elements as $e) {
			if (count($top_level_elements)==5){
				$el = array('ID'=>999999,'guid'=>'#','post_title'=>'More');
				$top_level_elements[] = $el;
				$post_parent_more = 999999;
			}
			if ( 0 == $e->$parent_field){
				if (count($top_level_elements)<5)
					$top_level_elements[] = $e;
				else if (count($top_level_elements)>=5)
					$children_elements[ $post_parent_more ][] = $e;
			}
			else{
				$children_elements[ $e->$parent_field ][] = $e;
			}
		}

		/*
		 * when none of the elements is top level
		 * assume the first one must be root of the sub elements
		 */
		/*if ( empty($top_level_elements) ) {

			$first = array_slice( $elements, 0, 1 );
			$root = $first[0];

			$top_level_elements = array();
			$children_elements  = array();
			foreach ( $elements as $e) {
				if ( $root->$parent_field == $e->$parent_field)
					$top_level_elements[] = $e;
				else
					$children_elements[ $e->$parent_field ][] = $e;
			}
		}

		foreach ( $top_level_elements as $e ){
			$this->display_element( $e, $children_elements, $max_depth, 0, $args, $output );
		}

		/*
		 * if we are displaying all levels, and remaining children_elements is not empty,
		 * then we got orphans, which should be displayed regardless
		 */
		/*if ( ( $max_depth == 0 ) && count( $children_elements ) > 0 ) {
			$empty_array = array();
			foreach ( $children_elements as $orphans )
				foreach( $orphans as $op )
					$this->display_element( $op, $empty_array, 1, 0, $args, $output );
		 }

		 return $output;
	}
}

function walk_page_tree_2($pages, $depth, $current_page, $r) {
	if ( empty($r['walker']) )
		$walker = new Walker_Page_More;
	else
		$walker = $r['walker'];

	$args = array($pages, $depth, $r, $current_page);
	return call_user_func_array(array(&$walker, 'walk_more'), $args);
}*/

function wp_list_pages_2($args = '') {
	$defaults = array(
		'depth' => 0, 'show_date' => '',
		'date_format' => get_option('date_format'),
		'child_of' => 0, 'exclude' => '',
		'title_li' => __('Pages'), 'echo' => 1,
		'authors' => '', 'sort_column' => 'menu_order, post_title'
	);

	$r = wp_parse_args( $args, $defaults );
	extract( $r, EXTR_SKIP );

	$output = '';
	$current_page = 0;

	// sanitize, mostly to keep spaces out
	$r['exclude'] = preg_replace('[^0-9,]', '', $r['exclude']);

	// Allow plugins to filter an array of excluded pages
	$r['exclude'] = implode(',', apply_filters('wp_list_pages_excludes', explode(',', $r['exclude'])));

	// Query pages.
	$r['hierarchical'] = 0;
	$pages = get_pages($r);

	foreach ($pages as $k=>$v)
	{
		$pages[$k]->post_title = '<span>' .$pages[$k]->post_title . '</span>';		
	}

	if ( !empty($pages) ) {
		if ( $r['title_li'] )
			$output .= '<li class="pagenav">' . add_span2title($r['title_li']) . '<ul>';

		global $wp_query;
		if ( is_page() || $wp_query->is_posts_page )
			$current_page = $wp_query->get_queried_object_id();
		$output .= walk_page_tree($pages, $r['depth'], $current_page, $r);
		
		if ( $r['title_li'] )
			$output .= '</ul></li>';
	}

	$output = apply_filters('wp_list_pages_2', $output);
	
	$output = str_replace('&lt;span&gt;','',$output);
	$output = str_replace('&lt;/span&gt;','',$output);
	
	//preg_match('()<li>()',$output);
	
	if ( $r['echo'] )
		echo $output;
	else
		return $output;
}

function comments_popup_link2( $zero = 'No Comments', $one = '1 Comment', $more = '% Comments', $css_class = '', $none = 'Comments Off' ) {
	global $id, $wpcommentspopupfile, $wpcommentsjavascript, $post;

	if ( is_single() || is_page() )
		return;

	$number = get_comments_number( $id );

	if ( 0 == $number && 'closed' == $post->comment_status && 'closed' == $post->ping_status ) {
		echo '<span' . ((!empty($css_class)) ? ' class="' . $css_class . '"' : '') . '>' . $none . '</span>';
		return;
	}

	if ( !empty($post->post_password) ) { // if there's a password
		if ( !isset($_COOKIE['wp-postpass_' . COOKIEHASH]) || $_COOKIE['wp-postpass_' . COOKIEHASH] != $post->post_password ) {  // and it doesn't match the cookie
			echo '<span>'.__('Enter your password to view comments').'</span>';
			return;
		}
	}

	echo '<span><a href="';
	if ( $wpcommentsjavascript ) {
		if ( empty( $wpcommentspopupfile ) )
			$home = get_option('home');
		else
			$home = get_option('siteurl');
		echo $home . '/' . $wpcommentspopupfile . '?comments_popup=' . $id;
		echo '" onclick="wpopen(this.href); return false"';
	} else { // if comments_popup_script() is not in the template, display simple comment link
		if ( 0 == $number )
			echo get_permalink() . '#respond';
		else
			comments_link();
		echo '"';
	}

	if ( !empty( $css_class ) ) {
		echo ' class="'.$css_class.'" ';
	}
	$title = attribute_escape( get_the_title() );

	echo apply_filters( 'comments_popup_link_attributes', '' );

	echo ' title="' . sprintf( __('Comment on %s'), $title ) . '">';
	comments_number( $zero, $one, $more, $number );
	echo '</a></span>';
}